function [Jfx,Jgx,Jfp,Jgp] = jac_Elowitz2000_6states(varargin)

    time = varargin{1};
    x = varargin{2};

    if nargout > 1
        % odeSD
        if nargin > 3
            p = varargin{4};
            
        else
            p = [20;2;40;2;10;0.5;0.0005;1];
        end
        if nargout > 1
            f = varargin{3};
        end
    else
        % MATLAB ODE integrators
        if nargin > 2
            p = varargin{3};
            
        else
            p = [20;2;40;2;10;0.5;0.0005;1];
        end
    end


    if nargout<1
        error('Too many output arguments');
    end

    Jfx = zeros(6, 6);
	Jfx(1) = -6243314768165359/(9007199254740992*p(5)*p(8));
	Jfx(5) = -(p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jfx(8) = -6243314768165359/(9007199254740992*p(5)*p(8));
	Jfx(12) = -(p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);
	Jfx(15) = -6243314768165359/(9007199254740992*p(5)*p(8));
	Jfx(16) = -(p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jfx(19) = (6243314768165359*p(1))/(9007199254740992*p(4)*p(8));
	Jfx(22) = -6243314768165359/(9007199254740992*p(4)*p(8));
	Jfx(26) = (6243314768165359*p(1))/(9007199254740992*p(4)*p(8));
	Jfx(29) = -6243314768165359/(9007199254740992*p(4)*p(8));
	Jfx(33) = (6243314768165359*p(1))/(9007199254740992*p(4)*p(8));
	Jfx(36) = -6243314768165359/(9007199254740992*p(4)*p(8));


    if nargout == 1
        return
    end

    Jgx = Jfx*Jfx;
	Jgx(5) = Jgx(5) + (2*f(1)*p(2)^2*p(3)^p(2)*(x(1)/p(8))^(2*p(2) - 2)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(1)/p(8))^p(2))^3) - (f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 2)*(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jgx(12) = Jgx(12) + (2*f(2)*p(2)^2*p(3)^p(2)*(x(2)/p(8))^(2*p(2) - 2)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(2)/p(8))^p(2))^3) - (f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 2)*(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);
	Jgx(16) = Jgx(16) + (2*f(3)*p(2)^2*p(3)^p(2)*(x(3)/p(8))^(2*p(2) - 2)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(3)/p(8))^p(2))^3) - (f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 2)*(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);


    if nargout == 2
        return
    end

    Jfp = zeros(6, 8);
	Jfp(1) = (6243314768165359*x(4))/(9007199254740992*p(4)*p(8));
	Jfp(2) = (6243314768165359*x(5))/(9007199254740992*p(4)*p(8));
	Jfp(3) = (6243314768165359*x(6))/(9007199254740992*p(4)*p(8));
	Jfp(10) = (p(3)^p(2)*log(p(3))*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(3)/p(8))^p(2)) - (p(3)^p(2)*(p(3)^p(2)*log(p(3)) + log(x(3)/p(8))*(x(3)/p(8))^p(2))*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(3)/p(8))^p(2))^2;
	Jfp(11) = (p(3)^p(2)*log(p(3))*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(1)/p(8))^p(2)) - (p(3)^p(2)*(p(3)^p(2)*log(p(3)) + log(x(1)/p(8))*(x(1)/p(8))^p(2))*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(1)/p(8))^p(2))^2;
	Jfp(12) = (p(3)^p(2)*log(p(3))*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(2)/p(8))^p(2)) - (p(3)^p(2)*(p(3)^p(2)*log(p(3)) + log(x(2)/p(8))*(x(2)/p(8))^p(2))*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(2)/p(8))^p(2))^2;
	Jfp(16) = (p(2)*p(3)^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(3)/p(8))^p(2)) - (p(2)*p(3)^p(2)*p(3)^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(3)/p(8))^p(2))^2;
	Jfp(17) = (p(2)*p(3)^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(1)/p(8))^p(2)) - (p(2)*p(3)^p(2)*p(3)^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(1)/p(8))^p(2))^2;
	Jfp(18) = (p(2)*p(3)^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(2)/p(8))^p(2)) - (p(2)*p(3)^p(2)*p(3)^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(3)^p(2) + (x(2)/p(8))^p(2))^2;
	Jfp(19) = -(6243314768165359*p(1)*x(4))/(9007199254740992*p(4)^2*p(8));
	Jfp(20) = -(6243314768165359*p(1)*x(5))/(9007199254740992*p(4)^2*p(8));
	Jfp(21) = -(6243314768165359*p(1)*x(6))/(9007199254740992*p(4)^2*p(8));
	Jfp(22) = (6243314768165359*x(4))/(9007199254740992*p(4)^2*p(8));
	Jfp(23) = (6243314768165359*x(5))/(9007199254740992*p(4)^2*p(8));
	Jfp(24) = (6243314768165359*x(6))/(9007199254740992*p(4)^2*p(8));
	Jfp(25) = (6243314768165359*x(1))/(9007199254740992*p(5)^2*p(8));
	Jfp(26) = (6243314768165359*x(2))/(9007199254740992*p(5)^2*p(8));
	Jfp(27) = (6243314768165359*x(3))/(9007199254740992*p(5)^2*p(8));
	Jfp(34) = (60*p(3)^p(2))/(p(3)^p(2) + (x(3)/p(8))^p(2));
	Jfp(35) = (60*p(3)^p(2))/(p(3)^p(2) + (x(1)/p(8))^p(2));
	Jfp(36) = (60*p(3)^p(2))/(p(3)^p(2) + (x(2)/p(8))^p(2));
	Jfp(40) = 60 - (60*p(3)^p(2))/(p(3)^p(2) + (x(3)/p(8))^p(2));
	Jfp(41) = 60 - (60*p(3)^p(2))/(p(3)^p(2) + (x(1)/p(8))^p(2));
	Jfp(42) = 60 - (60*p(3)^p(2))/(p(3)^p(2) + (x(2)/p(8))^p(2));
	Jfp(43) = (6243314768165359*x(1))/(9007199254740992*p(5)*p(8)^2) - (6243314768165359*p(1)*x(4))/(9007199254740992*p(4)*p(8)^2);
	Jfp(44) = (6243314768165359*x(2))/(9007199254740992*p(5)*p(8)^2) - (6243314768165359*p(1)*x(5))/(9007199254740992*p(4)*p(8)^2);
	Jfp(45) = (6243314768165359*x(3))/(9007199254740992*p(5)*p(8)^2) - (6243314768165359*p(1)*x(6))/(9007199254740992*p(4)*p(8)^2);
	Jfp(46) = (6243314768165359*x(4))/(9007199254740992*p(4)*p(8)^2) + (p(2)*p(3)^p(2)*x(3)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jfp(47) = (6243314768165359*x(5))/(9007199254740992*p(4)*p(8)^2) + (p(2)*p(3)^p(2)*x(1)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jfp(48) = (6243314768165359*x(6))/(9007199254740992*p(4)*p(8)^2) + (p(2)*p(3)^p(2)*x(2)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);


    if nargout == 3
        return
    end

    Jgp = Jfx*Jfp;
	Jgp(1) = Jgp(1) + (6243314768165359*f(4))/(9007199254740992*p(4)*p(8));
	Jgp(2) = Jgp(2) + (6243314768165359*f(5))/(9007199254740992*p(4)*p(8));
	Jgp(3) = Jgp(3) + (6243314768165359*f(6))/(9007199254740992*p(4)*p(8));
	Jgp(10) = Jgp(10) + (2*f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1)*(p(3)^p(2)*log(p(3)) + log(x(3)/p(8))*(x(3)/p(8))^p(2))*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^3) - (f(3)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2) - (f(3)*p(2)*p(3)^p(2)*log(p(3))*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2) - (log(x(3)/p(8))*f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jgp(11) = Jgp(11) + (2*f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1)*(p(3)^p(2)*log(p(3)) + log(x(1)/p(8))*(x(1)/p(8))^p(2))*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^3) - (f(1)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2) - (f(1)*p(2)*p(3)^p(2)*log(p(3))*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2) - (log(x(1)/p(8))*f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jgp(12) = Jgp(12) + (2*f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1)*(p(3)^p(2)*log(p(3)) + log(x(2)/p(8))*(x(2)/p(8))^p(2))*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^3) - (f(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2) - (f(2)*p(2)*p(3)^p(2)*log(p(3))*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2) - (log(x(2)/p(8))*f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);
	Jgp(16) = Jgp(16) + (2*f(3)*p(2)^2*p(3)^p(2)*p(3)^(p(2) - 1)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^3) - (f(3)*p(2)^2*p(3)^(p(2) - 1)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jgp(17) = Jgp(17) + (2*f(1)*p(2)^2*p(3)^p(2)*p(3)^(p(2) - 1)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^3) - (f(1)*p(2)^2*p(3)^(p(2) - 1)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jgp(18) = Jgp(18) + (2*f(2)*p(2)^2*p(3)^p(2)*p(3)^(p(2) - 1)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^3) - (f(2)*p(2)^2*p(3)^(p(2) - 1)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);
	Jgp(19) = Jgp(19) + -(6243314768165359*f(4)*p(1))/(9007199254740992*p(4)^2*p(8));
	Jgp(20) = Jgp(20) + -(6243314768165359*f(5)*p(1))/(9007199254740992*p(4)^2*p(8));
	Jgp(21) = Jgp(21) + -(6243314768165359*f(6)*p(1))/(9007199254740992*p(4)^2*p(8));
	Jgp(22) = Jgp(22) + (6243314768165359*f(4))/(9007199254740992*p(4)^2*p(8));
	Jgp(23) = Jgp(23) + (6243314768165359*f(5))/(9007199254740992*p(4)^2*p(8));
	Jgp(24) = Jgp(24) + (6243314768165359*f(6))/(9007199254740992*p(4)^2*p(8));
	Jgp(25) = Jgp(25) + (6243314768165359*f(1))/(9007199254740992*p(5)^2*p(8));
	Jgp(26) = Jgp(26) + (6243314768165359*f(2))/(9007199254740992*p(5)^2*p(8));
	Jgp(27) = Jgp(27) + (6243314768165359*f(3))/(9007199254740992*p(5)^2*p(8));
	Jgp(34) = Jgp(34) + -(60*f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jgp(35) = Jgp(35) + -(60*f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jgp(36) = Jgp(36) + -(60*f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);
	Jgp(40) = Jgp(40) + (60*f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jgp(41) = Jgp(41) + (60*f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jgp(42) = Jgp(42) + (60*f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);
	Jgp(43) = Jgp(43) + (6243314768165359*f(1))/(9007199254740992*p(5)*p(8)^2) - (6243314768165359*f(4)*p(1))/(9007199254740992*p(4)*p(8)^2);
	Jgp(44) = Jgp(44) + (6243314768165359*f(2))/(9007199254740992*p(5)*p(8)^2) - (6243314768165359*f(5)*p(1))/(9007199254740992*p(4)*p(8)^2);
	Jgp(45) = Jgp(45) + (6243314768165359*f(3))/(9007199254740992*p(5)*p(8)^2) - (6243314768165359*f(6)*p(1))/(9007199254740992*p(4)*p(8)^2);
	Jgp(46) = Jgp(46) + (6243314768165359*f(4))/(9007199254740992*p(4)*p(8)^2) + (f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(3)/p(8))^p(2))^2) - (2*f(3)*p(2)^2*p(3)^p(2)*x(3)*(x(3)/p(8))^(2*p(2) - 2)*(60*p(6) - 60*p(7)))/(p(8)^3*(p(3)^p(2) + (x(3)/p(8))^p(2))^3) + (f(3)*p(2)*p(3)^p(2)*x(3)*(x(3)/p(8))^(p(2) - 2)*(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^3*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
	Jgp(47) = Jgp(47) + (6243314768165359*f(5))/(9007199254740992*p(4)*p(8)^2) + (f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(1)/p(8))^p(2))^2) - (2*f(1)*p(2)^2*p(3)^p(2)*x(1)*(x(1)/p(8))^(2*p(2) - 2)*(60*p(6) - 60*p(7)))/(p(8)^3*(p(3)^p(2) + (x(1)/p(8))^p(2))^3) + (f(1)*p(2)*p(3)^p(2)*x(1)*(x(1)/p(8))^(p(2) - 2)*(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^3*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
	Jgp(48) = Jgp(48) + (6243314768165359*f(6))/(9007199254740992*p(4)*p(8)^2) + (f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^2*(p(3)^p(2) + (x(2)/p(8))^p(2))^2) - (2*f(2)*p(2)^2*p(3)^p(2)*x(2)*(x(2)/p(8))^(2*p(2) - 2)*(60*p(6) - 60*p(7)))/(p(8)^3*(p(3)^p(2) + (x(2)/p(8))^p(2))^3) + (f(2)*p(2)*p(3)^p(2)*x(2)*(x(2)/p(8))^(p(2) - 2)*(p(2) - 1)*(60*p(6) - 60*p(7)))/(p(8)^3*(p(3)^p(2) + (x(2)/p(8))^p(2))^2);


end

